import { Controller, Get } from '@nestjs/common';
import { AppService } from './app.service';
import * as fs from 'fs';
import { join } from 'path';

@Controller()
export class AppController {
  constructor(private readonly appService: AppService) {}

  @Get()
  getHello(): string {
    return this.appService.getHello();
  }

  @Get('version')
  async version() {
    const version = fs.readFileSync(
      join(process.cwd(), 'dist/version.txt'),
      'utf-8',
    );
    return { version };
  }
}
