import {Args, Context, Mutation, Query, Resolver} from '@nestjs/graphql';
import { AssetWorkflowService } from './assetworkflow.service';

@Resolver('AssetWorkflow')
export class AssetWorkflowResolver {
  constructor(private readonly service: AssetWorkflowService) {}
  @Mutation('createRechargeOrder')
  async createRechargeOrder(@Args('input') input, @Context() context) {
    return this.service.callGrpc('createRechargeOrder', input, context);
  }

  @Query('getOpenId')
  async getOpenId(@Args('input') input: any, @Context() context) {
    return await this.service.callGrpc('getOpenId', input, context);
  }
  @Query('queryUserInfo')
  async queryUserInfo(@Args('input') input: any, @Context() context) {
    return await this.service.callGrpc("queryUserInfo", input, context);
  }

}
