import {Injectable, OnModuleInit} from '@nestjs/common';
import {BaseGrpcService} from "@common/base.grpc.service";
import {Client, ClientGrpc, Transport} from "@nestjs/microservices";
import * as path from 'path';
import {join} from "path";

const projectRoot = path.resolve(__dirname, '../../..');
const protoPath = join(projectRoot, '/proto/vendor/asset-hera/assetworkflow.proto');
const url = `${process.env.G_ASSET_WORKFLOW_GRPC_HOST}:${process.env.G_ASSET_WORKFLOW_GRPC_PORT}`;

@Injectable()
export class AssetWorkflowService extends BaseGrpcService implements OnModuleInit  {
    @Client({
        transport: Transport.GRPC,
        options: {
            url: url,
            package: 'assetWorkflow',
            protoPath: protoPath,
        },
    })
    private client: ClientGrpc;

    onModuleInit() {
        this.setServiceClient(this.client, 'AssetWorkflowService');
    }

}