import { ObjectType } from '@nestjs/graphql';

@ObjectType()
export class PageResult<T> {
  totalElements: number;
  numberOfElements: number;
  totalPages: number;
  first: boolean;
  last: boolean;
  content: T[];

  constructor(data: {
    totalElements: number;
    numberOfElements: number;
    totalPages: number;
    first: boolean;
    last: boolean;
    content: T[];
  }) {
    this.totalElements = data.totalElements;
    this.numberOfElements = data.numberOfElements;
    this.totalPages = data.totalPages;
    this.first = data.first;
    this.last = data.last;
    this.content = data.content;
  }
}
