function toDecimal(str: number | string): number;
function toDecimal(str: number | string, decimals?: number): number;
function toDecimal(
  str: number | string,
  decimals?: number,
  keeptype?: boolean,
): string;
function toDecimal(
  str: number | string,
  decimals?: number,
  keeptype?: boolean,
) {
  decimals = decimals || 2;
  const num = (typeof str === 'string' ? parseFloat(str) : str) || 0;
  const _value =
    Math.abs(num) < Number.EPSILON
      ? 0
      : Number(
          Math.round(
            Number(
              num.toString().includes('e')
                ? num?.toString()
                : num?.toString() + 'e' + decimals,
            ),
          ) +
            'e-' +
            decimals,
        );
  if (typeof keeptype === 'undefined') {
    return _value;
  } else {
    return keeptype === false ? _value.toString() : _value.toFixed(decimals);
  }
}

function toPercent(str: number | string, decimals?: number) {
  return toDecimal(toDecimal(str, (decimals || 2) + 2) * 100, decimals) + '%';
}

function toNumber(number: number, limit: number = 2) {
  const numberString =
    parseFloat((number + '').replace(/[^\d\\.-]/g, '')).toFixed(limit) + '';
  const l = numberString.split('.')[0].split('').reverse();
  const r = numberString.split('.')[1];
  let t = '';
  for (let i = 0; i < l.length; i++) {
    t += l[i] + ((i + 1) % 3 === 0 && i + 1 !== l.length ? ',' : '');
  }
  return t.split('').reverse().join('') + '.' + r;
}

export { toNumber, toDecimal, toPercent };
