import { Args, Context, Mutation, Query, Resolver } from '@nestjs/graphql';
import { WalletService } from './wallet.service';

@Resolver('Wallet')
export class WalletResolver {
  constructor(private readonly service: WalletService) {}
  @Query('getUserWallet')
  async getUserWallet(@Args('input') input, @Context() context) {
    return this.service.callGrpc('getUserWallet', input, context);
  }

  @Query('queryUserWalletLogs')
  async queryUserWalletLogs(@Args('input') input, @Context() context) {
    let res = await this.service.callGrpc('queryUserWalletLogs', input, context);
    res.total = res?.total?? 0;
    res.result = res?.result?? [];
    return res;
  }

  @Query('getRechargeOrder')
  async getRechargeOrder(@Args('input') input, @Context() context) {
    return this.service.callGrpc('getRechargeOrder', input, context);
  }

}
