import {Injectable, OnModuleInit} from '@nestjs/common';
import * as path from 'path';
import { join } from 'path';
import { BaseGrpcService } from '@common/base.grpc.service';
import { Client, ClientGrpc, Transport } from '@nestjs/microservices';

const projectRoot = path.resolve(__dirname, '../../..');
const protoPath = join(projectRoot, '/proto/vendor/asset-hera/userwallet.proto');
const url = `${process.env.G_ASSET_WALLET_GRPC_HOST}:${process.env.G_ASSET_WALLET_GRPC_PORT}`;

@Injectable()
export class WalletService extends BaseGrpcService implements OnModuleInit  {
    @Client({
        transport: Transport.GRPC,
        options: {
            url: url,
            package: 'userWallet',
            protoPath: protoPath,
        },
    })
    private client: ClientGrpc;

    onModuleInit() {
        this.setServiceClient(this.client, 'UserWalletService');
    }

}
